; -------------------------------------------------
;    Flurry Code Off Competition Entry by Eikon       
; -------------------------------------------------
; 
; Includes my own Image->Data Converter (Img2Dat.bb)
  Include "Img2Dat.bb"
; Credits:
; Snarty for Gamma Fade in
; BasicGamer2 for his trees
; -------------------------------------------------
Graphics 640, 480, 16, 1
AppTitle "Flurry by Eikon"
SeedRnd(MilliSecs())

; -------------------------------------------------
;           
;                    I M A G E S
; 
; -------------------------------------------------
; Importing Images
Global Back = CreateImage(640, 215)
Import("back.txt")
GrabImage(Back, 0, 0)
Cls

Global Sky = CreateImage(640, 345)
CSky()
GrabImage(Sky, 0, 0)
Cls

; Importing snowflake 
Global Flake = CreateImage(23, 23, 2)
Import("flake.txt")
GrabImage(Flake, 0, 0, 0)
GrabImage(Flake, 23, 0, 1)
MaskImage Flake, 255, 255, 255
MidHandle Flake

; Importing SnowMan
Global Snowman = CreateImage(88, 179)
Import("sman.txt")
GrabImage(Snowman, 0, 0)
MaskImage Snowman, 255, 0, 255

; Trees Generated with BasicGamer2's program
; (Used with permission)
Global Tree1 = CreateImage(212, 399)
Import("tree1.txt")
GrabImage(Tree1, 0, 0)

Global Tree2 = CreateImage(245, 320)
Import("tree2.txt")
GrabImage(Tree2, 0, 0)


SetBuffer BackBuffer() ; Images are Parsed

; -------------------------------------------------
;           
;                  V A R I A B L E S
; 
; -------------------------------------------------
; FPS Counter
Global FPS = 0, Frames = 0, Time# = MilliSecs() + 1
Global FFrame = 0, FY = 0, FT = MilliSecs()
Global MTime = CreateTimer(60)
Global GI#=0, GS#=.02
Global Parts = 0, Panel = 1

Type Snow
	Field X#
	Field Y#
	Field D ; Direction
	Field F ; Frame
	Field T ; Timer
	Field C ; Color
	Field I#; Inertia
	Field K ; Kind
	Field ID# ; Interia Direction
	Field S ; Size
End Type

Type Burst
	Field X#
	Field Y#
	Field XS# ; XInertia
	Field YS# ; YInertia
	Field B ; Color
	Field S
End Type

Type Bank
	Field X#
	Field Y#
	Field C ; Color
	Field S ; Size
	Field L ; Lifetime
	Field T ; Timer
	Field F ; Fall?
End Type

; -------------------------------------------------
;           
;                      M A I N
; 
; -------------------------------------------------

While Not KeyDown(1)
Cls
Frames = Frames + 1
If MilliSecs() >= Time Then	FPS = Frames: Frames = 0: Time = Time + 1000 ; FPS Counter

If GI < 1 Then ; Gamma Fade In
	For I = 0 To 255
		SetGamma I, I, I, I*GI, I*GI, I*GI
	Next

	UpdateGamma False
	
	GI=GI+GS
EndIf

CSnow()
DrawImage Sky, 0, 0
DrawImage Back, 0, 265
DrawImage Tree1, 45, 45
DrawImage Tree2, 410, 160
DrawImage Snowman, 217, 290
RBank() 
RSnow()
RBurst()

If Panel = 1 Then ; Info 
	Color 255, 255, 255: Text 1, 1, "Used VidMem: " + (TotalVidMem() - AvailVidMem())/1024 + "kb"
	Text 1, 16, "FPS: " + FPS
	Text 1, 32, "Particles: " + Parts
	Color 0, 0, 0: Text 1, 464, "Press (T) to Toggle Text"
EndIf

If KeyHit(20) Then
	If Panel = 1 Then Panel = 0: Goto Wait
	If Panel = 0 Then Panel = 1
EndIf

.Wait
WaitTimer MTime
Flip False
Wend
End

; -------------------------------------------------
;           
;                 F U N C T I O N S
; 
; -------------------------------------------------
Function CSky() ; Creating Sky
B = 0 ; Blue
R = 0
For Y = 0 To 345 Step 2
	Color R/2, 0, B
	Rect 0, Y, 640, 5, 1 
	B = B + 2
	R = R + 1
	If B>= 255 Then B = 255
Next
End Function

Function CSnow()
s.Snow = New Snow
	s\X = Rand(0, 639)
	s\K = Rand(0, 20)
	s\D = Rand(0, 1)
	If s\K = 10 Then 
		s\F = 0
		s\Y = -30
	Else
		s\Y = -1
	EndIf
	s\T = MilliSecs()
	s\C = Rand(90, 255)
	s\I = 1
	s\ID = Rnd(-.5, -1)
	s\S = Rand(1, 2)
	Parts = Parts + 1
End Function

Function CBurst(X, Y, Num)
For I = 0 To Num
	b.Burst = New burst
	b\X = X
	b\Y = Y
	b\XS = -Sin(Rand(0, 359)) * Rnd(.5, 1.5)
	b\YS = Cos(Rand(0, 359)) * Rnd(.5, 1.5)
	b\B = 255
	b\S = 2
	Parts = Parts + 1
Next
End Function
	
Function AddBank(X, Y, C, S)
a.Bank = New Bank
a\X = X
a\Y = Y
a\C = C
a\S = S
Parts = Parts + 1
a\L = Rand(2000, 7000)
a\T = MilliSecs()
a\F = 0
End Function

Function RSnow()
For s.Snow = Each Snow
	If s\D = 0 Then ; Left
		s\X = s\X - s\I
		s\I = s\I - .01
		If s\I <= s\ID Then s\D = 1: s\I = 1
	EndIf
	
	If s\D = 1 Then ; Right
		s\X = s\X + s\I
		s\I = s\I - .01
		If s\I <= s\ID Then s\D = 0: s\I = 1
	EndIf
	
	s\Y = s\Y + 1
	
	If s\K = 10 Then ; Flake Image
		DrawImage Flake, s\X, s\Y, s\F
		If MilliSecs() >= s\T + 200 Then s\F = s\F + 1: s\T = MilliSecs()
		If s\F = 2 Then s\F = 0
		If ImagesCollide(Flake, s\X, s\Y, s\F, Tree1, 45, 45, 0) Then Del = 1
		If ImagesCollide(Flake, s\X, s\Y, s\F, Tree2, 410, 160, 0) Then Del = 1
		If ImagesCollide(Flake, s\X, s\Y, s\F, Snowman, 217, 290, 0) Then Del = 1
		If Del = 1 Then CBurst(s\X, s\Y, 50)
	Else
		Color s\C, s\C, s\C
		Rect s\X, s\Y, s\S, s\S, 1
		If Parts < 1000 ; Limit 
			If ImageRectCollide(Tree1, 45, 45, 0, s\X, s\Y, s\S, s\S) Then AddBank(s\X, s\Y, s\C, s\S): Del = 1
			If ImageRectCollide(Tree2, 410, 160, 0, s\X, s\Y, s\S, s\S) Then AddBank(s\X, s\Y, s\C, s\S): Del = 1
		EndIf
	EndIf
	
	If s\Y > 480 Or Del = 1 Then Delete s: Parts = Parts - 1
	Del = 0
Next
End Function

Function RBurst()
For b.Burst = Each Burst
	b\X = b\X - b\XS
	b\Y = b\Y - b\YS
	b\B = b\B - 4
	Color b\B, b\B, b\B
	If b\B < 177 Then b\S = 1
	Rect b\X, b\Y, b\S, b\S, 1
	If b\B < 100 Then Delete b: Parts = Parts - 1
Next
End Function

Function RBank()
For a.Bank = Each Bank
	Color a\C, a\C, a\C
	If a\F = 1 Then a\Y = a\Y + 1
	Rect a\X, a\Y, a\S, a\S, 1
	If MilliSecs() >= a\T + a\L Then a\F = 1
	If a\Y >= 480 Then Delete a: Parts = Parts - 1
Next
End Function


	
